// Generated by LiveScript 1.4.0
(function(){
  var me, split$ = ''.split;
  module.exports = me = {
    parse: function(conf, opts){
      var defaults;
      if (conf instanceof Buffer) {
        conf = conf.toString();
      }
      if (typeof conf !== 'string') {
        throw new Error('conf must be a string or buffer');
      }
      opts = import$(clone$(defaults = {
        asArray: false,
        comment: '#',
        sep: ':'
      }), opts);
      return parse(1, split$.call(conf, '\n'), (opts.rx = {
        comment: new RegExp("^([^" + opts.comment + "]*)")
      }, opts));
    },
    valueParser: function(raw){
      var str;
      if (!(str = raw.trim()).length) {
        return null;
      }
      if (str === 'true') {
        return true;
      }
      if (str === 'false') {
        return false;
      }
      if (/^[-\+]?\d+$/.test(str)) {
        return parseInt(str, 10);
      }
      if (/^[-\+]?\d+\.\d+$/.test(str)) {
        return parseFloat(str);
      }
      return str;
    }
  };
  function parse(offset, lines, opts){
    var i, sep, seplen, res, li, isFollowedByNestedSubconf, isSep, k, sublines, suboffset, subind, ref$, sepidx;
    i = -1;
    sep = opts.sep;
    seplen = sep.length;
    res = opts.asArray
      ? []
      : {};
    function append(v, k){
      var ref$;
      if (opts.asArray && k) {
        return res.push((ref$ = {}, ref$[k + ""] = v, ref$));
      }
      if (opts.asArray) {
        return v != null ? res.push(v) : void 8;
      }
      if (k) {
        return res[k] = v;
      } else {
        if (v == null) {
          return;
        }
      }
      if (typeof res === 'string') {
        return err('string', v);
      } else {
        return res = v;
      }
    }
    function getIndent(line){
      return /^(\s*)/.exec(line)[0].length;
    }
    function stripComment(line){
      return opts.rx.comment.exec(line)[0];
    }
    function err(what, x){
      throw new Error("Unexpected " + what + " at line " + (i + offset) + ":'" + x + "'");
    }
    while (++i < lines.length) {
      if (0 !== getIndent(li = stripComment(lines[i]))) {
        err('indent', li);
      }
      if (isFollowedByNestedSubconf = getIndent(lines[1 + i])) {
        isSep = (li = li.trim()).slice(-seplen) === sep;
        k = isSep ? li.slice(0, -seplen) : li;
        if (!(k = k.length ? k : void 8)) {
          err('empty key', li);
        }
        sublines = [];
        suboffset = offset + i + 1;
        while (i++ < lines.length && getIndent(li = lines[i])) {
          if (li.substr(0, subind != null
            ? subind
            : subind = getIndent(li)).trim().length) {
            err('outdent', li);
          }
          sublines.push(li.slice(subind));
        }
        append(parse(suboffset, sublines, (ref$ = clone$(opts), ref$.asArray = !isSep, ref$)), k);
        i--;
      } else {
        isSep = (sepidx = li.indexOf(sep)) > -1;
        k = isSep ? li.slice(0, sepidx).trim() : '';
        if (isSep && !(k = k.length ? k : void 8)) {
          err('empty key', li);
        }
        append(me.valueParser(isSep ? li.slice(seplen + sepidx) : li), k);
      }
    }
    return res;
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);
